#ifndef __CONFIG_H__
#define __CONFIG_H__

#ifdef WIN32
#   define strcasecmp _stricmp
#endif

#include "../include/tinyxml/tinyxml.h"
#include "../main/agent/communication/ConnectionType.h"

/* Player Atributes */	
class PlayerConfig
{
public: 
    char team[100];					/*< Team name */
    int id;							/*< Agent ID */

	PlayerConfig();
};


/* configuration class */
class Config
{
private:
	TiXmlDocument xmlDocument;			/*< Input XML files */

public:
    char serverIP[100];					/*< server IP */
    unsigned short serverPort;			/*< server port */
	sockaddr_in server;					/*< server structure*/
    ConnectionType connectionType;		/*< used connection type (TCP or UDP) */
    PlayerConfig *player;				/*< player class */

    static bool getAttributeString(TiXmlElement* pElement, const char *pAttribute, char *string, unsigned int stringSize);
    static bool getAttributeInt(TiXmlElement* pElement, const char *pAttribute, int &integer);
    static bool getAttributeDouble(TiXmlElement* pElement, const char *pAttribute, double &num);
	
	int loadConfig(const char *xmlFile);
	Config();
	~Config();
};

#endif /*__CONFIG_H__*/
