/*
 * Agent.cpp
 */

#include "Agent.h"
#include <stdio.h>
#include <sstream>
#include <iostream>
#include <string>
//#include <time.h>

using namespace std;

#define SENDINGMESSAGESIZE 4093
#define RECEIVINGMESSAGESIZE 4093

Agent::Agent() {
}

Agent * Agent::INSTANCE = new Agent();

Agent * Agent::getInstance() {
	return INSTANCE;
}

void Agent::initialize(bool *run, ConnectionType protocol, struct sockaddr *server, char *team,int *id,int skill)
{
	this->run = run;
	char sendingMessage[SENDINGMESSAGESIZE];
	char receivingMessage[RECEIVINGMESSAGESIZE];
	parser = new Parser();
	behaviour = new Behaviour(team,skill);
	
	communication = new Communication(protocol);
	if (*run && !communication->setServer(server))
	{
		*run = false;
	}
#ifdef WIN32
	sprintf_s(sendingMessage, SENDINGMESSAGESIZE, "(scene rsg/agent/nao/nao.rsg)");
#else
	sprintf(sendingMessage, "(scene rsg/agent/nao/nao.rsg)");
#endif
	if (*run && !communication->send(sendingMessage))
	{
		*run = false;
	}
	while (*run && !communication->select(1, 0))
	{
	}
	while (*run && communication->select(0, 0))
	{
		if (!communication->receive(receivingMessage, RECEIVINGMESSAGESIZE))
		{
			*run = false;
		}
	}
#ifdef WIN32
	sprintf_s(sendingMessage, SENDINGMESSAGESIZE, "(init (unum %i)(teamname %s))", *id, team);
#else
	sprintf(sendingMessage, "(init (unum %i)(teamname %s))", *id, team);
#endif
	if (*run && !communication->send(sendingMessage))
	{
		*run = false;
	}
}

void Agent::start()
{
	char receivingMessage[RECEIVINGMESSAGESIZE];
	message.setf(ios::fixed);
	message.precision(2);
	/*clock_t start,stop;*/

	while (*run)
	{
		while (*run && !communication->select(1, 0))
		{
		}

		while (*run && communication->select(0, 0))
		{
			if (!communication->receive(receivingMessage, RECEIVINGMESSAGESIZE))
			{
				*run = false;
			}
		}

		if (*run)
		{
			/*start = clock();*/
			message.str("");
			bool parseTest = parser->parseData(receivingMessage);
			//cout << receivingMessage << endl << endl;

			if (!parseTest)
			{
				continue;
			}

			behaviour->nextStep(parser->apgparser.GetStoredData());

			/*stop = clock();*/
			//cout << (double)(stop - start) / CLOCKS_PER_SEC << endl;
			//cout << (double)(stop - start)<< endl;
		}

		if (*run && !communication->send(message.str().data()))
		{
			*run = false;
		}
	}
}

void Agent::addToMessage(string &s){
	this->message<<s;
}

Agent::~Agent()
{
	delete communication;
	delete behaviour;
	delete parser;
	
}