/*
 * Agent.h
 */

#ifndef AGENT_H_
#define AGENT_H_

#include "../config/Config.h"
#include "agent/Behaviour.h"
#include "agent/Communication.h"
#include "agent/parser/Parser.h"

class Behaviour;
class Dispatcher;

class Agent
{
private:
	bool *run;
	Behaviour *behaviour;
	Communication *communication;
	Parser *parser;
	Dispatcher *dispatcher;
	stringstream message;
	static Agent * INSTANCE;
	Agent();
	virtual ~Agent();

	Agent(const Agent & agent);
    Agent & operator=(const Agent & agent);

public:
	void start();
	void addToMessage(string &s);
	void initialize(bool *run, ConnectionType protocol, struct sockaddr *server, char *team,int *id, int skill);
	
	static Agent * getInstance();
};

#endif /*AGENT_H_*/
