#include "Behaviour.h"
#include "behaviour/dispatcher/Dispatcher.h"
#include <string.h>
#include <iostream>
using namespace std;

Behaviour::Behaviour(char *team, int aSkill)
{
	worldModel = new WorldModel();
	teamBehaviour = new TeamBehaviour();
	agentModel = AgentModel::getInstance();
	states = new States(worldModel);
	dispatcher = new Dispatcher();
	agentModel ->skill = aSkill;
}

void Behaviour::nextStep(ServerMsgParserData *parsedData)
{
	worldModel->update(parsedData);
	agentModel->update(parsedData);
	states->update();
	
	dispatcher->proceed(states);
	
	teamBehaviour->Action(worldModel,agentModel);
}

Behaviour::~Behaviour()
{
	//delete agentModel;
	delete teamBehaviour;
	delete worldModel;
	delete states;
}
