/*
 * Communication.h
 */

#ifndef COMMUNICATION_H_
#define COMMUNICATION_H_

#include "communication/TCPSocket.h"
#include "communication/UDPSocket.h"
#include "communication/ConnectionType.h"

class Communication
{
private:
	TCPSocket *tcpSocket;
	UDPSocket *udpSocket;
	struct sockaddr *server;
public:
	Communication(ConnectionType protocol);
	bool setServer(struct sockaddr *server);
	bool send(const char *message);
	bool select(int seconds, int microseconds);
	bool receive(char *message, int messageSize);
	virtual ~Communication();
};

#endif /*COMMUNICATION_H_*/
