#ifndef AGENTMODEL_H_
#define AGENTMODEL_H_

#include "worldmodel/effectorset/StringStream.h"
#include "agentModel/Joints.h"
#include "../parser/ServerMsgParserOpt.h"
#include "agentModel/ForceResistance.h"
#include "agentModel/Gyroscope.h"


#include <vector>

const double PI = 3.1415926;

//obsahuje zlozenie celeho robota: klby
class AgentModel: public StringStream
{
private:
	AgentModel();
	virtual ~AgentModel();

	AgentModel(const AgentModel & agentModel);
    AgentModel & operator=(const AgentModel & agentModel);

	static AgentModel * INSTANCE;
public:

	static AgentModel * getInstance();

	double simTime;						/*!< Simulation time perceptor*/
	int skill;
	Gyroscope * gyroscope;				/*!< Gyroscope perceptor*/
	ForceResistance *FRP;				/*!< ForceResistance perceptor */
	//HearPerceptor hear;					/*!< Hear perceptor */
	THingeJointSenseMap mHingeJointSenseMap;
	TJointIDMap mJointIDMap;

	

//	void SetupJointIDMap();
	double GetJointAngleDeg(JointID jid);
	double GetJointAngleRad(JointID jid);
	string Action();
	void update(ServerMsgParserData *parsedData);
	string generate();
	
    
	int type_1;
	int step_1;
	void initSkillMoveHands();
	string executeSkillMoveHands();

	int faza;
	int counter;
	void initSkillRound();
	string executeSkillRound();

	int step;
	int foot;
	void initSkillMove();
	string executeSkillMove();

	string executeSkillSalute();

	string executeSkillMove2();

	string executeSquat();
	string executeFallDown();
	string moveRoundOnEarth();

	string executeMoveLeft();
	void executeStabilisation(JointID jid, string str, double deg);
	bool isStable(JointID jid, double deg);

	string executeSkillRun();
	string executeSkillDrepuj();
};


#endif //AGENTMODEL_H_