#pragma once
#include <stdio.h>
#include "../highSkills/HighSkill.h"
#include "States.h"
#include "../skillsFactory/XMLSkillsFactory.h"

using namespace std;

class Dispatcher
{
private:
	//vector, which holds all skills
	vector <HighSkill*> skills;
	//flag, that indicates that it is necessary to replan the current executing action
	bool forceReplan;
	//aktivne prebiehajuci skill
	HighSkill *activeSkill;

	//makes decision which skill to use in case of equal skill usability
	HighSkill *decideBetweenEqualSkills(HighSkill *skillA, HighSkill *skillB);
	//chooses random skill between two skills
	HighSkill *chooseRandomSkill(HighSkill *SkillA, HighSkill *skillB);
	HighSkill *replanAction(States *states);
	//adds new skill to list of skills
	void addSkill(HighSkill *skill);
	//executes next phase of current skill
	void performCurrentAction(States *states);
	//replans action, when excludeActiveSkill flag is true, then *activeSkill is excluded from list of choosed skills.
 	HighSkill *replanAction(States *states, bool excludeActiveSkill);

public:
	Dispatcher();
	~Dispatcher(void);
	//force to replan current executing skill, despite it hasn't finished
	void forceReplanAction();
	//metoda na urcenie vhodnosti preplanovania
	void overrideCurrentAction();
	//execute action
	void proceed(States *states);
};
