#include "HighSkill.h"
#include "..\lowSkills\MovementPhase.h"

HighSkill::HighSkill(string & name)
{
	this->name = name;
}

HighSkill::~HighSkill(void)
{
	delete activeMovementPhaze;
	delete &usability;
}

void HighSkill::addLowSkill(LowSkill *lowSkill) {
	this->assignLowSkill(lowSkill);
}

int HighSkill::getPreviousUsability()
{
	return usability;
}

int HighSkill::calculateUsability(States *states)
{
	this->usability = getUsability(states);
	return this->usability;
}

HighSkill *HighSkill::compareUsability(HighSkill *other, States *states)
{
	if(other == NULL){
		return this;
	}
	int otherUsability = other->calculateUsability(states);
	int thisUsability = this->calculateUsability(states);

	if(thisUsability > otherUsability)
	{
		return this;
	}
	else if(thisUsability < otherUsability)
	{
		return other;
	}
	else
	{
		return NULL;
	}
}

bool HighSkill::robotIsOnGround(States * states)
{
	return states->isOnGround();
}

void HighSkill::execute(States *state)
{
	performStateCheck(state);
	executeLowSkill();
}