#pragma once
#include "../dispatcher/States.h"
//#include "../LowSkills/MovementPhase.h"
#include "../AgentModel.h"

class LowSkill;
class MovementPhase;

//abstract class, which will be inherited by subclasses, which will represent skills of robot

class HighSkill
{
private:
	int usability;
	string name;

	int calculateUsability(States *states);

protected:
	//aktivne prebiehajuca faza, naposledy volana
	MovementPhase *activeMovementPhaze;
	
public:
	HighSkill(string & name);
	~HighSkill(void);

	void addLowSkill(LowSkill *lowSkill);
	void execute(States *states);
	//compares usability of this skill with other skill (using canPerform() method. If the usability is equal, returns NULL.
	HighSkill *compareUsability(HighSkill *other, States *states);
	//returns previous usabilitiy
	int getPreviousUsability();
	//makes assignment of the low skill to some attribute
	virtual void assignLowSkill(LowSkill *lowSkill) = 0;
	//indicates how can this skill be usefull in the current world state
	virtual int getUsability(States *states) = 0;
	//performs next movement phase
	virtual void executeLowSkill() = 0;
	//performs checking about current state of robot, and throws exception if something is wrong...
	virtual void performStateCheck(States *state) = 0;
	//indicates, if the current skill has finished its purpose
	virtual bool hasFinished() = 0;
	//indicates if the current skill is in phase, which can be replaned 
	virtual bool isInReplanableState() = 0;
	//fidns out from state, if robot is on the ground
	bool robotIsOnGround(States * states);
};