#pragma once

#include <vector>

#include "../AgentModel.h"
#include "../../../Agent.h"
#include "PhaseData.h"
#include "PhaseCache.h"

using namespace std;

class Agent;

class MovementPhase
{

private:
	vector<double> anglesPrevExecution;
	AgentModel * model;
	PhaseData * data;
	double speedConstant;
	bool MovementPhase::checkFinished(void);
	bool MovementPhase::checkIncrement(void);
	void MovementPhase::updatePreviousAngles(void);
	void sendMessage(void);
	int MovementPhase::sign(double &d);
public:
	MovementPhase(AgentModel * model, PhaseData * data);
	~MovementPhase(void);
	void MovementPhase::initialize(void);
	bool MovementPhase::check(void);
	bool MovementPhase::isFinal(void);
	MovementPhase * MovementPhase::calculateRescuePhase(void);
	MovementPhase * MovementPhase::getFinalizationPhase(void);
	MovementPhase * MovementPhase::getNextPhase(void);
	void MovementPhase::interrupt(void);
	void MovementPhase::proceed(void);
};
