/*
 * EffectorSet.cpp
 */

#include "EffectorSet.h"

EffectorSet::EffectorSet()
{
	beam = new Beam[BEAMCOUNT]();
	beamCount = 0;
	hingeJoint = new HingeJoint[HINGEJOINTCOUNT]();
	hingeJointCount = 0;
	say = new Say[SAYCOUNT]();
	sayCount = 0;
}

string EffectorSet::generate(void)
{
	int i = 0;
	ss.str("");

	for (int j = 0; j < beamCount; j ++)
	{
		ss << beam[j].generate();
	}
	beamCount = 0;
	
	for (int j = 0; j < hingeJointCount; j ++)
	{
		ss << hingeJoint[j].generate();
	}
	hingeJointCount = 0;
	
	for (int j = 0; j < sayCount; j ++)
	{
		ss << say[j].generate();
	}
	sayCount = 0;

	return ss.str();
}

EffectorSet::~EffectorSet()
{
	delete[] say;
	delete[] hingeJoint;
	delete[] beam;
}
